require 'ictr'
require 'idarub'

ida, = IdaRub.auto_client

ida.print "Starting\n"

total, opcodes = count_instructions(ida);

ida.print "Done\n"

sorted = opcodes.sort {|a, b| b[1]<=>a[1]}

printf "Opcode distribution of file: %s\n", ida.get_input_file_path()
printf "Total number of opcodes: %i\n\n", total

sorted.each_with_index {|o, i|
	printf "%04i. %06i %8.2f%%      %s\n", i+1, o[1], 100.0 * o[1] / total, o[0]
}
